local world = require('world')
local pulleyTest = {}

-- Counterweight
pulleyTest.cw = love.physics.newBody(world,200,0,'dynamic')
pulleyTest.cwShape = love.physics.newRectangleShape(10,20)
pulleyTest.cwFix = love.physics.newFixture(pulleyTest.cw,pulleyTest.cwShape)

-- Main block
pulleyTest.mainBody = love.physics.newBody(world,0,0,'dynamic')
pulleyTest.mainShape = love.physics.newRectangleShape(10,10)
pulleyTest.mainFix = love.physics.newFixture(pulleyTest.mainBody,pulleyTest.mainShape)

-- Pulley
pulleyTest.pulley = love.physics.newPulleyJoint(pulleyTest.mainBody,pulleyTest.cw,0,-200,200,-200,0,0,0,0)

-- Boundary Block
pulleyTest.block = love.physics.newBody(world,100,-200)
pulleyTest.blockShape = love.physics.newRectangleShape(400,200)
pulleyTest.blockFix = love.physics.newFixture(pulleyTest.block,pulleyTest.blockShape)

-- Set Fixed Rotation,restrict movement to one axis
pulleyTest.mainBody:setFixedRotation(true)
pulleyTest.cw:setFixedRotation(true)
pulleyTest.restrictJoint1 = love.physics.newPrismaticJoint(pulleyTest.mainBody,pulleyTest.block,0,0,0,1)
pulleyTest.restrictJoint2 = love.physics.newPrismaticJoint(pulleyTest.cw,pulleyTest.block,200,0,0,1)

-- Print Masses
print('Counterweight Mass:', pulleyTest.cw:getMass(),', Main block Mass:',pulleyTest.mainBody:getMass())

-- Draw
pulleyTest.draw = function(self)
	love.graphics.setColor(1,1,1)
	love.graphics.polygon('fill',self.mainBody:getWorldPoints(self.mainShape:getPoints()))
	love.graphics.polygon('fill',self.cw:getWorldPoints(self.cwShape:getPoints()))
	love.graphics.polygon('fill',self.block:getWorldPoints(self.blockShape:getPoints()))
end

return pulleyTest